# Index

For APIs not in this index, see [here](./API/index.md).
For the meaning of terms, see [here](./dev_guide/terms.md) for the meaning of terms.

## Symbols

* !
  * !-type → [Mutable type](./type/mut.md)
* [&#35;](./00_basic.md/#comment)
* $
* %
* &
  * &&
* &prime; (single quote)
* &lpar;&rpar;
* &ast;
  * [*-less multiplication](./01_literal.md/#less-multiplication)
* &plus; (unary)
  * &plus;_ → &plus; (unary)
* &plus; (binary)
* ,
* &minus; (unary)
  * &minus;_ → &minus; (unary)
* &minus; (binary)
  * &minus;>
* . → [Visibility]
* /
* :
  * :]
* ;
* &lt;
  * &lt;:
  * &lt;&lt;
  * &lt;=
* =
  * ==
  * =>
* &gt;
  * &gt;&gt;
  * &gt;=
* ?
* @
* []
* \
* ^
  * ^^
* _
  * &#95;+&#95; → &plus; (binary)
  * &#95;-&#95; → &minus; (binary)
* ``
* {}
  * {} type
* {:}
* {=}
  * {=} type
* |
  * ||
* ~

## Alphabet

### A

* [algebraic&nbsp;type]
* [And]
* [and]
* [assert]
* [attribute]

### B

* [Base]
* [Bool]

### C

* [Class]

### D

* Deprecated
* [distinct]

### E

* [enum&nbsp;type]
* [Eq]
* [Erg]

### F

* [for]

### G

### H

### I

* [if]
* [import]
* [in]
* [Int]

### J

### K

### L

* let-polymorphism → [rank-1 polymorphism]
* [log]

### M

* [match]

### N

* [Nat]
* Never
* None
* None
* [Not]
* [not]

### O

* [Option]
* [Or]
* [or]
* [Ord]

### P

* panic
* [print!](./../API/procs.md#print)
* [Python]

### Q

### R

* ref
* ref!
* [Result]
* [rootobj]

### S

* self
* [Self](./type/special.md)
* [side-effect](./07_side_effect.md)
* [Str]

### T

* Trait
* [True]
* [Type]
* [type]

### U

### V

### W

* [while!]

### X

### Y

### Z
